# --
# Copyright (C) CEA, EDF
# Author : Erwan ADAM (CEA)
# --

from circle import Circle

c = Circle(r=1.0)

assert c.r == 1.0

bounds = c.bounds

assert bounds == [-1.0, 1.0, -1.0, 1.0]

from material import Material

m = Material()

assert m.name == "m"

from technologyobject import TechnologyObject

to = TechnologyObject(material=m,
                      shape=c,
                      )

c = to.shape

assert c.r == 1.0
assert c.bounds == [-1.0, 1.0, -1.0, 1.0]
